﻿using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.button.Click += button_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 테스트 버튼 클릭시 처리하기 - button_Click(sender, e)

        /// <summary>
        /// 테스트 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private async void button_Click(object sender, RoutedEventArgs e)
        {
            Task task = new TaskFactory().StartNew
            (
                async () =>
                {
                    Application.Current.Dispatcher.Invoke
                    (
                        () =>
                        {
                            Mouse.OverrideCursor = Cursors.Wait;

                            this.button.IsEnabled = false;
                        }
                    );

                    await Task.Delay(10000);

                    Application.Current.Dispatcher.Invoke
                    (
                        () =>
                        {
                            Mouse.OverrideCursor = null;

                            this.button.IsEnabled = true;
                        }
                    );
                }
            );

            await task;
        }

        #endregion
    }
}